// Global Vars
var MHWVersion = 2.0;
var scoresURL = "http://macheist.seems.nl/";
var widgetMessageURL = "http://74.53.235.126/~taimhome/MacHeist/WidgetMessage.htm";
var widgetVersionURL = "http://74.53.235.126/~taimhome/MacHeist/WidgetVersion.htm";

// Scores
var blueScore = 0;
var bluePosit = 0;
var greenScore = 0;
var greenPosit = 0;
var orangeScore = 0;
var orangePosit = 0;
var purpleScore = 0;
var purplePosit = 0;


// Called when widget is loaded
function load()
{
    dashcode.setupParts();
    updateScores();
}

// Called when widget is shown
function show()
{
    updateScores();
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    updateMessage();
    updateVersion();
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
    {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget)
    {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget)
{
    widget.onshow = show;
}



function updateScores()
{
    var onloadHandler = function() { scoresLoaded(scoresRequest); };

    var scoresRequest = new XMLHttpRequest();
    scoresRequest.onload = onloadHandler;
    scoresRequest.open("GET", scoresURL);
    scoresRequest.setRequestHeader("Cache-Control", "no-cache");
    scoresRequest.send(null);
}

function updateMessage()
{
    var onloadHandler = function() { messageLoaded(messageRequest); };

    var messageRequest = new XMLHttpRequest();
    messageRequest.onload = onloadHandler;
    messageRequest.open("GET", widgetMessageURL);
    messageRequest.setRequestHeader("Cache-Control", "no-cache");
    messageRequest.send(null);

}

function updateVersion()
{
    var onloadHandler = function() { versionLoaded(versionRequest); };
    
    var versionRequest = new XMLHttpRequest();
    versionRequest.onload = onloadHandler;
    versionRequest.open("GET", widgetVersionURL);
    versionRequest.setRequestHeader("Cache-Control", "no-cache");
    versionRequest.send(null);
}

function scoresLoaded(scoresRequest) 
{
	if (scoresRequest.status == 200)
    {
        var rankingRegEx = new RegExp( "<ul id=\"ranking\">([^]*?)</ul>", "mg" ); 
        var matchString = rankingRegEx.exec(scoresRequest.responseText);
        var rankingDom = document.createElement("div");
        rankingDom.innerHTML = matchString[1];
        
        blueScore = getElementsByClass("score", getElementsByClass("blue", rankingDom, "li")[0], "span")[0].innerHTML;
        bluePosit = getElementsByClass("pos", getElementsByClass("blue", rankingDom, "li")[0], "span")[0].innerHTML.substring(0,1);
        
        greenScore = getElementsByClass("score", getElementsByClass("green", rankingDom, "li")[0], "span")[0].innerHTML;
        greenPosit = getElementsByClass("pos", getElementsByClass("green", rankingDom, "li")[0], "span")[0].innerHTML.substring(0,1);

        orangeScore = getElementsByClass("score", getElementsByClass("orange", rankingDom, "li")[0], "span")[0].innerHTML;
        orangePosit = getElementsByClass("pos", getElementsByClass("orange", rankingDom, "li")[0], "span")[0].innerHTML.substring(0,1);

        purpleScore = getElementsByClass("score", getElementsByClass("purple", rankingDom, "li")[0], "span")[0].innerHTML;
        purplePosit = getElementsByClass("pos", getElementsByClass("purple", rankingDom, "li")[0], "span")[0].innerHTML.substring(0,1);

        document.getElementById("Blue").innerHTML = blueScore;
        document.getElementById("BluePos").innerHTML = bluePosit;
        document.getElementById("Green").innerHTML = greenScore;
        document.getElementById("GreenPos").innerHTML = greenPosit;
        document.getElementById("Orange").innerHTML = orangeScore;
        document.getElementById("OrangePos").innerHTML = orangePosit;
        document.getElementById("Purple").innerHTML = purpleScore;
        document.getElementById("PurplePos").innerHTML = purplePosit;
        
        var winningPosit = parseInt(bluePosit);
        var winningTeam = "Blue";
        if (parseInt(greenPosit) < winningPosit)
        {
            winningPosit = parseInt(greenPosit);
            winningTeam = "Green";
        }
        if (parseInt(orangePosit) < winningPosit)
        {
            winningPosit = parseInt(orangePosit);
            winningTeam = "Orange";
        }
        if (parseInt(purplePosit) < winningPosit)
        {
            winningPosit = parseInt(purplePosit);
            winningTeam = "Purple";
        }

        document.getElementById("Winning").innerHTML = winningTeam + " is Winning!";

        document.getElementById("blue").style.opacity = 1.0;
        document.getElementById("green").style.opacity = 1.0;
        document.getElementById("orange").style.opacity = 1.0;
        document.getElementById("purple").style.opacity = 1.0;
        
        document.getElementById(winningTeam.toLowerCase()).style.opacity = 0.0;
	}
	else
    {
		alert("Error fetching data: HTTP status " + scoresRequest.status);
	}
}

function messageLoaded(messageRequest)
{
    var latestMessage = "Unable to get latest message";
    if (messageRequest.status == 200)
    {
        latestMessage = messageRequest.responseText;
	}
    var scrollArea = document.getElementById("messageArea");
    scrollArea.object.content.innerHTML = latestMessage;
    scrollArea.object.refresh();
}

function versionLoaded(versionRequest)
{
    if (versionRequest.status == 200)
    {
        var latestVersion = versionRequest.responseText;
        if (parseFloat(latestVersion) > MHWVersion)
        {
            var versionIndicator = document.getElementById("needsUpdate");
            versionIndicator.object.setValue(20);
        }
        else
        {
            var versionIndicator = document.getElementById("needsUpdate");
            versionIndicator.object.setValue(1);
        }
	}
	else
    {
		alert("Error fetching data: HTTP status " + messageRequest.status);
	}
}

// http://www.dustindiaz.com/getelementsbyclass/
function getElementsByClass(searchClass,node,tag)
{
	var classElements = new Array();
	if ( node == null )
		node = document;
	if ( tag == null )
		tag = '*';
	var els = node.getElementsByTagName(tag);
	var elsLen = els.length;
	var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
	for (i = 0, j = 0; i < elsLen; i++) {
		if ( pattern.test(els[i].className) ) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}

function loadUpdateURL()
{
    widget.openURL("http://74.53.235.126/~taimhome/MacHeist/updatingWidget.htm");
}